# -*- coding: utf-8 -*-
"""DL1_bouston_sidNew.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1wY027XfeEsHYy7tom-vvIVUfc5TWjw-8
"""

pip install scikit-learn==1.1.0

import numpy as np
from sklearn.datasets import load_boston
from sklearn.preprocessing import StandardScaler
from sklearn.model_selection import train_test_split
from keras.models import Sequential
from keras.layers import Dense

# Load the Boston Housing dataset
boston = load_boston()

# Split the dataset into features and target
X = boston.data
y = boston.target

# Standardize the features
scaler = StandardScaler()
X = scaler.fit_transform(X)

# Split the dataset into training and testing sets
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2, random_state=42)

print(boston.DESCR)

import pandas as pd
df=pd.DataFrame(X, columns=boston.feature_names)
df.head()

model = Sequential()
model.add(Dense(1, input_dim=X.shape[1], activation='linear'))

# Compile the model
model.compile(loss='mean_squared_error', optimizer='adam')

model.fit(X_train, y_train, epochs=100, batch_size=32, verbose=1)

# Evaluate the model on the testing set
mse = model.evaluate(X_test, y_test)
print('Mean Squared Error:', mse)

